;##################################################################
; GDIPlus Scribble
;##################################################################

STRINGS UNICODE

#include "GdipScribble.h"

DEBUGLIB equ \Programming\RadASM\GoAsm\lib\Debug.lib
DEBUGEXE equ "\Programming\RadAsm\GoAsm\lib\dbgwin.exe"

#include "\Programming\RadASM\GoAsm\inc\debug.a"
DBGWIN_DEBUG_ON = 1 // use this to enable Spy/StopSpy/DbgDump and TrapException
DBGWIN_SHOWONLYERRORS = 1 // setting this to 1 will suppress PrintError if no error exists 

#Define S @ADDRESSWIDTH/8

CONST SECTION
	ImageEncoderBMP GUID GUID_ImageEncoderBMP
	ImageEncoderJPEG GUID GUID_ImageEncoderJPEG
	ImageEncoderPNG GUID GUID_ImageEncoderPNG
	ImageEncoderGIF GUID GUID_ImageEncoderGIF
	ImageEncoderTIFF GUID GUID_ImageEncoderTIFF
	ImageEncoderEMF GUID GUID_ImageEncoderEMF
	ImageEncoderWMF GUID GUID_ImageEncoderWMF
	ImageEncoderICON GUID GUID_ImageEncoderICON

	BlurEffectGuid GUID GUID_BlurEffectGuid
	BrightnessContrastEffectGuid GUID GUID_BrightnessContrastEffectGuid
	ColorBalanceEffectGuid GUID GUID_ColorBalanceEffectGuid
	ColorCurveEffectGuid GUID GUID_ColorCurveEffectGuid
	ColorLookupTableEffectGuid GUID GUID_ColorLookupTableEffectGuid
	ColorMatrixEffectGuid GUID GUID_ColorMatrixEffectGuid
	HueSaturationLightnessEffectGuid GUID GUID_HueSaturationLightnessEffectGuid
	LevelsEffectGuid GUID GUID_LevelsEffectGuid
	RedEyeCorrectionEffectGuid GUID GUID_RedEyeCorrectionEffectGuid
	SharpenEffectGuid GUID GUID_SharpenEffectGuid
	TintEffectGuid GUID GUID_TintEffectGuid

DATA SECTION

	GDIPlusToken	ULONG_PTR			0
	gdipsi			GdiplusStartupInput	<1,0,0,0>
	pPic			PTR 0

	// Handles used in the example
	hInstance	HANDLE ?
	hPictureBox	HANDLE ?
	hPencil		HANDLE ?
	hFill		HANDLE ?
	hCrosshair	HANDLE ?
	hPicker		HANDLE ?

	PixelFormat	DD		PixelFormat32bppARGB

	hAlpha		HANDLE ?
	hAlphaEdit	HANDLE ?

	fDrawing	BOOL ?
	Oldpt		POINT <>
	Newpt		POINT <>
	BkgndBrush	HANDLE ?
	pEditGraphics PTR ?

	// The SCHAR type changes to DUS when STRINGS UNICODE is defined
	BmpEditClass		SCHAR	"Picturebox_class",0
	PaletteClass		SCHAR	"Palette_class",0

	VersionString		TCHAR	256 DUP (?)

CODE SECTION

START:

	invoke GetModuleHandle, 0
	mov [hInstance],eax
	
	// Load the cursors
	invoke LoadCursors
	// Initialize custom classes
	invoke InitClasses
	// COM must be initialized
	invoke CoInitialize,NULL
	// Turn on common controls
	invoke InitCommonControls

	// Start GDI+
	invoke GdiplusStartup,offset GDIPlusToken,offset gdipsi,NULL

	// Display the dialog
	invoke DialogBoxParam,[hInstance],1000,0,ADDR DlgProc,0

	invoke GdiplusShutdown,[GDIPlusToken]
	// Turn COM off
	invoke CoUninitialize
	invoke ExitProcess,0

LoadCursors:
	// Pencil cursor
	invoke LoadImage,NULL,"Cursors\Pencil.cur",IMAGE_CURSOR,0,0,LR_LOADFROMFILE
	mov [hPencil],rax

	// Line shape cursor
	invoke LoadImage,NULL,"Cursors\CrossHair.cur",IMAGE_CURSOR,0,0,LR_LOADFROMFILE
	mov [hCrosshair],rax

	// Fill cursor
	invoke LoadImage,NULL,"Cursors\Fill.cur",IMAGE_CURSOR,0,0,LR_LOADFROMFILE
	mov [hFill],rax

	// color picker cursor
	invoke LoadImage,NULL,"Cursors\ColorPicker.cur",IMAGE_CURSOR,0,0,LR_LOADFROMFILE
	mov [hPicker],rax
	RET

InitClasses FRAME
	LOCAL cix:WNDCLASSEX

	invoke RtlZeroMemory,offset cix,SIZEOF WNDCLASSEX

	mov rax,[hPencil]
	mov [cix.hCursor],rax
	mov D[cix.style],CS_OWNDC or CS_HREDRAW or CS_VREDRAW
	mov D[cix.cbSize],SIZEOF WNDCLASSEX
	mov rax,[hInstance]
	mov [cix.hInstance],rax
	mov D[cix.lpszClassName],offset BmpEditClass
	mov D[cix.cbWndExtra],28
	mov D[cix.cbClsExtra], NULL
	mov D[cix.hbrBackground], COLOR_WINDOW+1
	mov D[cix.lpfnWndProc], offset PictureBoxProc
	invoke RegisterClassEx,offset cix

	mov rax,[hPicker]
	mov [cix.hCursor],rax
	mov D[cix.style],CS_OWNDC or CS_HREDRAW or CS_VREDRAW
	mov D[cix.cbSize],SIZEOF WNDCLASSEX
	mov rax,[hInstance]
	mov [cix.hInstance],rax
	mov D[cix.lpszClassName],offset PaletteClass
	mov D[cix.cbWndExtra],28
	mov D[cix.cbClsExtra], NULL
	mov D[cix.hbrBackground], NULL
	mov D[cix.lpfnWndProc], offset PaletteProc
	invoke RegisterClassEx,offset cix

	RET
ENDF

GetVersionString FRAME pApplication,pszVersion
	uses edi,ebx,esi
	LOCAL Verifictaion	:D
	LOCAL RootPath		:D
	LOCAL pVersion		:D
	LOCAL pVersionLen	:D

	invoke GetFileVersionInfoSize,[pApplication],OFFSET Verifictaion
	or eax,eax
	jnz >
		jmp >>.ERROR
	:

	push eax
	invoke GlobalAlloc,040h,eax
	mov ebx,eax
	pop eax
	invoke GetFileVersionInfo,[pApplication],0,eax,ebx
	mov D[RootPath],"\"
	invoke VerQueryValue,ebx,OFFSET RootPath,OFFSET pVersion,OFFSET pVersionLen
	or eax,eax
	jnz >
		jmp >>.ERROR
	:

	mov esi,[pVersion]
	mov eax,[esi+VS_FIXEDFILEINFO.dwFileVersionMS]
	mov edx,eax
	and edx,0FFFFh ;Version.MajorLow
	shr eax,16
	mov ecx,eax ;Version.Major

	mov eax,[esi+VS_FIXEDFILEINFO.dwFileVersionLS]
	mov edi,eax
	and edi,0FFFFh ;Version.MinorLow
	shr eax,16 ;Version.Minor

	cmp D[pszVersion],0
	je >
		CInvoke(wsprintf, [pszVersion], OFFSET VersionFormat, ecx, edx, eax, edi)
	:

	mov edx,[esi+VS_FIXEDFILEINFO.dwFileVersionLS]
	mov eax,[esi+VS_FIXEDFILEINFO.dwFileVersionMS]

	push eax,edx
	invoke GlobalFree,ebx
	pop edx,eax
	ret

	.ERROR
	invoke lstrcpy,[pszVersion],offset szDLLVNoVersion
	invoke SetLastError,13
	xor edx,edx
	xor eax,eax
	dec eax
	ret

	VersionFormat:		SCHAR	"%u.%u.%u.%u",0
	szDLLVNoVersion:	SCHAR	"0.0.0.0",0

ENDF

PaletteProc FRAME hwnd,uMsg,wParam,lParam
	uses ebx
	LOCAL pPalettePic:%PTR
	LOCAL pGraphics:%PTR
	LOCAL rect:RECT
	LOCAL pt:POINT
	LOCAL bmd:BitmapData
	LOCAL ps:PAINTSTRUCT
	LOCAL color:%COLORREF

	// Build the palette
	cmp D[uMsg],WM_CREATE
	jne >>.WM_LBUTTONDOWN
		invoke GetClientRect,[hwnd],offset rect

		invoke GdipCreateFromHWND, [hwnd], offset pGraphics

		mov D[rect.right],12
		mov D[rect.bottom],12

		invoke GdipCreateBitmapFromGraphics,[rect.right], [rect.bottom],[pGraphics],offset pPalettePic
		invoke GdipDeleteGraphics, [pGraphics]

		invoke SetWindowLong,[hwnd],GWL_USERDATA, [pPalettePic]
		invoke GdipBitmapLockBits,[pPalettePic],NULL,ImageLockModeWrite + ImageLockModeRead,[PixelFormat],offset bmd

		invoke GdipSetBitmapPixel,0,0,[bmd.Scan0],[bmd.Stride],Black
		invoke GdipSetBitmapPixel,1,0,[bmd.Scan0],[bmd.Stride],0xFF151515
		invoke GdipSetBitmapPixel,2,0,[bmd.Scan0],[bmd.Stride],0xFF2A2A2A
		invoke GdipSetBitmapPixel,3,0,[bmd.Scan0],[bmd.Stride],0xFF3F3F3F
		invoke GdipSetBitmapPixel,4,0,[bmd.Scan0],[bmd.Stride],0xFF545454
		invoke GdipSetBitmapPixel,5,0,[bmd.Scan0],[bmd.Stride],0xFF696969
		invoke GdipSetBitmapPixel,6,0,[bmd.Scan0],[bmd.Stride],0xFF7E7E7E
		invoke GdipSetBitmapPixel,7,0,[bmd.Scan0],[bmd.Stride],0xFF939393
		invoke GdipSetBitmapPixel,8,0,[bmd.Scan0],[bmd.Stride],0xFFA8A8A8
		invoke GdipSetBitmapPixel,9,0,[bmd.Scan0],[bmd.Stride],0xFFBDBDBD
		invoke GdipSetBitmapPixel,10,0,[bmd.Scan0],[bmd.Stride],0xFFD2D2D2
		invoke GdipSetBitmapPixel,11,0,[bmd.Scan0],[bmd.Stride],White

		invoke GdipSetBitmapPixel,0,1,[bmd.Scan0],[bmd.Stride],0xFF640000
		invoke GdipSetBitmapPixel,1,1,[bmd.Scan0],[bmd.Stride],0xFF720000
		invoke GdipSetBitmapPixel,2,1,[bmd.Scan0],[bmd.Stride],0xFF800000
		invoke GdipSetBitmapPixel,3,1,[bmd.Scan0],[bmd.Stride],0xFF8E0000
		invoke GdipSetBitmapPixel,4,1,[bmd.Scan0],[bmd.Stride],0xFF9C0000
		invoke GdipSetBitmapPixel,5,1,[bmd.Scan0],[bmd.Stride],0xFFAA0000
		invoke GdipSetBitmapPixel,6,1,[bmd.Scan0],[bmd.Stride],0xFFB80000
		invoke GdipSetBitmapPixel,7,1,[bmd.Scan0],[bmd.Stride],0xFFC60000
		invoke GdipSetBitmapPixel,8,1,[bmd.Scan0],[bmd.Stride],0xFFD40000
		invoke GdipSetBitmapPixel,9,1,[bmd.Scan0],[bmd.Stride],0xFFE20000
		invoke GdipSetBitmapPixel,10,1,[bmd.Scan0],[bmd.Stride],0xFFF00000
		invoke GdipSetBitmapPixel,11,1,[bmd.Scan0],[bmd.Stride],0xFFFF0000

		invoke GdipSetBitmapPixel,0,2,[bmd.Scan0],[bmd.Stride],0xFF006400
		invoke GdipSetBitmapPixel,1,2,[bmd.Scan0],[bmd.Stride],0xFF007200
		invoke GdipSetBitmapPixel,2,2,[bmd.Scan0],[bmd.Stride],0xFF008000
		invoke GdipSetBitmapPixel,3,2,[bmd.Scan0],[bmd.Stride],0xFF008E00
		invoke GdipSetBitmapPixel,4,2,[bmd.Scan0],[bmd.Stride],0xFF009C00
		invoke GdipSetBitmapPixel,5,2,[bmd.Scan0],[bmd.Stride],0xFF00AA00
		invoke GdipSetBitmapPixel,6,2,[bmd.Scan0],[bmd.Stride],0xFF00B800
		invoke GdipSetBitmapPixel,7,2,[bmd.Scan0],[bmd.Stride],0xFF00C600
		invoke GdipSetBitmapPixel,8,2,[bmd.Scan0],[bmd.Stride],0xFF00D400
		invoke GdipSetBitmapPixel,9,2,[bmd.Scan0],[bmd.Stride],0xFF00E200
		invoke GdipSetBitmapPixel,10,2,[bmd.Scan0],[bmd.Stride],0xFF00F000
		invoke GdipSetBitmapPixel,11,2,[bmd.Scan0],[bmd.Stride],0xFF00FF00

		invoke GdipSetBitmapPixel,0,3,[bmd.Scan0],[bmd.Stride],0xFF000064
		invoke GdipSetBitmapPixel,1,3,[bmd.Scan0],[bmd.Stride],0xFF000072
		invoke GdipSetBitmapPixel,2,3,[bmd.Scan0],[bmd.Stride],0xFF000080
		invoke GdipSetBitmapPixel,3,3,[bmd.Scan0],[bmd.Stride],0xFF00008E
		invoke GdipSetBitmapPixel,4,3,[bmd.Scan0],[bmd.Stride],0xFF00009C
		invoke GdipSetBitmapPixel,5,3,[bmd.Scan0],[bmd.Stride],0xFF0000AA
		invoke GdipSetBitmapPixel,6,3,[bmd.Scan0],[bmd.Stride],0xFF0000B8
		invoke GdipSetBitmapPixel,7,3,[bmd.Scan0],[bmd.Stride],0xFF0000C6
		invoke GdipSetBitmapPixel,8,3,[bmd.Scan0],[bmd.Stride],0xFF0000D4
		invoke GdipSetBitmapPixel,9,3,[bmd.Scan0],[bmd.Stride],0xFF0000E2
		invoke GdipSetBitmapPixel,10,3,[bmd.Scan0],[bmd.Stride],0xFF0000F0
		invoke GdipSetBitmapPixel,11,3,[bmd.Scan0],[bmd.Stride],0xFF0000FF

		invoke GdipSetBitmapPixel,0,4,[bmd.Scan0],[bmd.Stride],0xFFC00064
		invoke GdipSetBitmapPixel,1,4,[bmd.Scan0],[bmd.Stride],0xFFC00072
		invoke GdipSetBitmapPixel,2,4,[bmd.Scan0],[bmd.Stride],0xFFC00080
		invoke GdipSetBitmapPixel,3,4,[bmd.Scan0],[bmd.Stride],0xFFC0008E
		invoke GdipSetBitmapPixel,4,4,[bmd.Scan0],[bmd.Stride],0xFFC0009C
		invoke GdipSetBitmapPixel,5,4,[bmd.Scan0],[bmd.Stride],0xFFC000AA
		invoke GdipSetBitmapPixel,6,4,[bmd.Scan0],[bmd.Stride],0xFFC000B8
		invoke GdipSetBitmapPixel,7,4,[bmd.Scan0],[bmd.Stride],0xFFC000C6
		invoke GdipSetBitmapPixel,8,4,[bmd.Scan0],[bmd.Stride],0xFFC000D4
		invoke GdipSetBitmapPixel,9,4,[bmd.Scan0],[bmd.Stride],0xFFC000E2
		invoke GdipSetBitmapPixel,10,4,[bmd.Scan0],[bmd.Stride],0xFFC000F0
		invoke GdipSetBitmapPixel,11,4,[bmd.Scan0],[bmd.Stride],0xFFC000FF

		invoke GdipSetBitmapPixel,0,5,[bmd.Scan0],[bmd.Stride],0xFF0064C0
		invoke GdipSetBitmapPixel,1,5,[bmd.Scan0],[bmd.Stride],0xFF0072C0
		invoke GdipSetBitmapPixel,2,5,[bmd.Scan0],[bmd.Stride],0xFF0080C0
		invoke GdipSetBitmapPixel,3,5,[bmd.Scan0],[bmd.Stride],0xFF008EC0
		invoke GdipSetBitmapPixel,4,5,[bmd.Scan0],[bmd.Stride],0xFF009CC0
		invoke GdipSetBitmapPixel,5,5,[bmd.Scan0],[bmd.Stride],0xFF00AAC0
		invoke GdipSetBitmapPixel,6,5,[bmd.Scan0],[bmd.Stride],0xFF00B8C0
		invoke GdipSetBitmapPixel,7,5,[bmd.Scan0],[bmd.Stride],0xFF00C6C0
		invoke GdipSetBitmapPixel,8,5,[bmd.Scan0],[bmd.Stride],0xFF00D4C0
		invoke GdipSetBitmapPixel,9,5,[bmd.Scan0],[bmd.Stride],0xFF00E2C0
		invoke GdipSetBitmapPixel,10,5,[bmd.Scan0],[bmd.Stride],0xFF00F0C0
		invoke GdipSetBitmapPixel,11,5,[bmd.Scan0],[bmd.Stride],0xFF00FFC0

		invoke GdipSetBitmapPixel,0,6,[bmd.Scan0],[bmd.Stride],0xFF6400C0
		invoke GdipSetBitmapPixel,1,6,[bmd.Scan0],[bmd.Stride],0xFF7200C0
		invoke GdipSetBitmapPixel,2,6,[bmd.Scan0],[bmd.Stride],0xFF8000C0
		invoke GdipSetBitmapPixel,3,6,[bmd.Scan0],[bmd.Stride],0xFF8E00C0
		invoke GdipSetBitmapPixel,4,6,[bmd.Scan0],[bmd.Stride],0xFF9C00C0
		invoke GdipSetBitmapPixel,5,6,[bmd.Scan0],[bmd.Stride],0xFFAA00C0
		invoke GdipSetBitmapPixel,6,6,[bmd.Scan0],[bmd.Stride],0xFFB800C0
		invoke GdipSetBitmapPixel,7,6,[bmd.Scan0],[bmd.Stride],0xFFC600C0
		invoke GdipSetBitmapPixel,8,6,[bmd.Scan0],[bmd.Stride],0xFFD400C0
		invoke GdipSetBitmapPixel,9,6,[bmd.Scan0],[bmd.Stride],0xFFE200C0
		invoke GdipSetBitmapPixel,10,6,[bmd.Scan0],[bmd.Stride],0xFFF000C0
		invoke GdipSetBitmapPixel,11,6,[bmd.Scan0],[bmd.Stride],0xFFFF00C0

		invoke GdipSetBitmapPixel,0,7,[bmd.Scan0],[bmd.Stride],0xFF64C0C0
		invoke GdipSetBitmapPixel,1,7,[bmd.Scan0],[bmd.Stride],0xFF72C0C0
		invoke GdipSetBitmapPixel,2,7,[bmd.Scan0],[bmd.Stride],0xFF80C0C0
		invoke GdipSetBitmapPixel,3,7,[bmd.Scan0],[bmd.Stride],0xFF8EC0C0
		invoke GdipSetBitmapPixel,4,7,[bmd.Scan0],[bmd.Stride],0xFF9CC0C0
		invoke GdipSetBitmapPixel,5,7,[bmd.Scan0],[bmd.Stride],0xFFAAC0C0
		invoke GdipSetBitmapPixel,6,7,[bmd.Scan0],[bmd.Stride],0xFFB8C0C0
		invoke GdipSetBitmapPixel,7,7,[bmd.Scan0],[bmd.Stride],0xFFC6C0C0
		invoke GdipSetBitmapPixel,8,7,[bmd.Scan0],[bmd.Stride],0xFFD4C0C0
		invoke GdipSetBitmapPixel,9,7,[bmd.Scan0],[bmd.Stride],0xFFE2C0C0
		invoke GdipSetBitmapPixel,10,7,[bmd.Scan0],[bmd.Stride],0xFFF0C0C0
		invoke GdipSetBitmapPixel,11,7,[bmd.Scan0],[bmd.Stride],0xFFFFC0C0

		invoke GdipSetBitmapPixel,0,8,[bmd.Scan0],[bmd.Stride],0xFFC0C064
		invoke GdipSetBitmapPixel,1,8,[bmd.Scan0],[bmd.Stride],0xFFC0C072
		invoke GdipSetBitmapPixel,2,8,[bmd.Scan0],[bmd.Stride],0xFFC0C080
		invoke GdipSetBitmapPixel,3,8,[bmd.Scan0],[bmd.Stride],0xFFC0C08E
		invoke GdipSetBitmapPixel,4,8,[bmd.Scan0],[bmd.Stride],0xFFC0C09C
		invoke GdipSetBitmapPixel,5,8,[bmd.Scan0],[bmd.Stride],0xFFC0C0AA
		invoke GdipSetBitmapPixel,6,8,[bmd.Scan0],[bmd.Stride],0xFFC0C0B8
		invoke GdipSetBitmapPixel,7,8,[bmd.Scan0],[bmd.Stride],0xFFC0C0C6
		invoke GdipSetBitmapPixel,8,8,[bmd.Scan0],[bmd.Stride],0xFFC0C0D4
		invoke GdipSetBitmapPixel,9,8,[bmd.Scan0],[bmd.Stride],0xFFC0C0E2
		invoke GdipSetBitmapPixel,10,8,[bmd.Scan0],[bmd.Stride],0xFFC0C0F0
		invoke GdipSetBitmapPixel,11,8,[bmd.Scan0],[bmd.Stride],0xFFC0C0FF

		invoke GdipSetBitmapPixel,0,9,[bmd.Scan0],[bmd.Stride],0xFF906490
		invoke GdipSetBitmapPixel,1,9,[bmd.Scan0],[bmd.Stride],0xFF907290
		invoke GdipSetBitmapPixel,2,9,[bmd.Scan0],[bmd.Stride],0xFF908090
		invoke GdipSetBitmapPixel,3,9,[bmd.Scan0],[bmd.Stride],0xFF908E90
		invoke GdipSetBitmapPixel,4,9,[bmd.Scan0],[bmd.Stride],0xFF909C90
		invoke GdipSetBitmapPixel,5,9,[bmd.Scan0],[bmd.Stride],0xFF90AA90
		invoke GdipSetBitmapPixel,6,9,[bmd.Scan0],[bmd.Stride],0xFF90B890
		invoke GdipSetBitmapPixel,7,9,[bmd.Scan0],[bmd.Stride],0xFF90C690
		invoke GdipSetBitmapPixel,8,9,[bmd.Scan0],[bmd.Stride],0xFF90D490
		invoke GdipSetBitmapPixel,9,9,[bmd.Scan0],[bmd.Stride],0xFF90E290
		invoke GdipSetBitmapPixel,10,9,[bmd.Scan0],[bmd.Stride],0xFF90F090
		invoke GdipSetBitmapPixel,11,9,[bmd.Scan0],[bmd.Stride],0xFF90FF90

		invoke GdipSetBitmapPixel,0,10,[bmd.Scan0],[bmd.Stride],0xFF649090
		invoke GdipSetBitmapPixel,1,10,[bmd.Scan0],[bmd.Stride],0xFF729090
		invoke GdipSetBitmapPixel,2,10,[bmd.Scan0],[bmd.Stride],0xFF809090
		invoke GdipSetBitmapPixel,3,10,[bmd.Scan0],[bmd.Stride],0xFF8E9090
		invoke GdipSetBitmapPixel,4,10,[bmd.Scan0],[bmd.Stride],0xFF9C9090
		invoke GdipSetBitmapPixel,5,10,[bmd.Scan0],[bmd.Stride],0xFFAA9090
		invoke GdipSetBitmapPixel,6,10,[bmd.Scan0],[bmd.Stride],0xFFB89090
		invoke GdipSetBitmapPixel,7,10,[bmd.Scan0],[bmd.Stride],0xFFC69090
		invoke GdipSetBitmapPixel,8,10,[bmd.Scan0],[bmd.Stride],0xFFD49090
		invoke GdipSetBitmapPixel,9,10,[bmd.Scan0],[bmd.Stride],0xFFE29090
		invoke GdipSetBitmapPixel,10,10,[bmd.Scan0],[bmd.Stride],0xFFF09090
		invoke GdipSetBitmapPixel,11,10,[bmd.Scan0],[bmd.Stride],0xFFFF9090

		invoke GdipSetBitmapPixel,0,11,[bmd.Scan0],[bmd.Stride],0xFF909064
		invoke GdipSetBitmapPixel,1,11,[bmd.Scan0],[bmd.Stride],0xFF909072
		invoke GdipSetBitmapPixel,2,11,[bmd.Scan0],[bmd.Stride],0xFF909080
		invoke GdipSetBitmapPixel,3,11,[bmd.Scan0],[bmd.Stride],0xFF90908E
		invoke GdipSetBitmapPixel,4,11,[bmd.Scan0],[bmd.Stride],0xFF90909C
		invoke GdipSetBitmapPixel,5,11,[bmd.Scan0],[bmd.Stride],0xFF9090AA
		invoke GdipSetBitmapPixel,6,11,[bmd.Scan0],[bmd.Stride],0xFF9090B8
		invoke GdipSetBitmapPixel,7,11,[bmd.Scan0],[bmd.Stride],0xFF9090C6
		invoke GdipSetBitmapPixel,8,11,[bmd.Scan0],[bmd.Stride],0xFF9090D4
		invoke GdipSetBitmapPixel,9,11,[bmd.Scan0],[bmd.Stride],0xFF9090E2
		invoke GdipSetBitmapPixel,10,11,[bmd.Scan0],[bmd.Stride],0xFF9090F0
		invoke GdipSetBitmapPixel,11,11,[bmd.Scan0],[bmd.Stride],0xFF9090FF

		invoke GdipBitmapUnlockBits,[pPalettePic],offset bmd
		jmp >>.DEFPROC

	.WM_LBUTTONDOWN
	cmp D[uMsg],WM_LBUTTONDOWN
	jne >>.WM_PAINT
		invoke GetWindowLong,[hwnd],GWL_USERDATA
		mov [pPalettePic],rax
		invoke GetCursorPos,offset pt
		invoke ScreenToClient,[hwnd],offset pt
		shr D[pt.x],4 // divide by 16 to get the offset in the bitmap
		shr D[pt.y],4
		invoke GdipBitmapLockBits,[pPalettePic],NULL,ImageLockModeRead,[PixelFormat],offset bmd
		invoke GdipGetBitmapPixel,[pt.x],[pt.y],[bmd.Scan0],[bmd.Stride]
		push eax
		invoke GdipBitmapUnlockBits,[pPalettePic],offset bmd
		pop ebx
		and ebx,0xFFFFFF
		invoke SendMessage,[hAlpha],TBM_GETPOS,0,0
		sub eax,255
		neg eax
		shl eax,AlphaShift
		or eax,ebx
		invoke SetWindowLong,[hPictureBox],0,eax
		jmp >>.DEFPROC

	.WM_PAINT
	cmp D[uMsg],WM_PAINT
	jne >>.DEFPROC
		invoke GetWindowLong,[hwnd],GWL_USERDATA
		mov [pPalettePic],rax

		invoke BeginPaint,[hwnd],offset ps
		invoke GetClientRect,[hwnd],offset rect
		invoke GdipCreateFromHDC,[ps.hdc], offset pGraphics
		invoke GdipSetPixelOffsetMode,[pGraphics],PixelOffsetModeHighQuality
		invoke GdipSetInterpolationMode,[pGraphics],InterpolationModeHighQualityBicubic
		invoke GdipDrawImageRectI,[pGraphics],[pPalettePic],0,0,[rect.right], [rect.bottom]
		invoke GdipDeleteGraphics, [pGraphics]
		invoke EndPaint,[hwnd],offset ps
		xor rax,rax
		ret

	.DEFPROC
	invoke DefWindowProc, [hwnd], [uMsg], [wParam], [lParam]
	RET
ENDF

PictureBoxProc FRAME hwnd, uMsg, wParam, lParam
	uses ebx,esi,edi
	LOCAL ps		:PAINTSTRUCT
	LOCAL rect		:RECT
	LOCAL pt		:POINT
	LOCAL bmd		:BitmapData
	LOCAL Scale		:D
	LOCAL color		:%COLORREF

// Window memory
// GWL_USERDATA = Current bitmap
// 0 = current color

	.WM_CREATE
	cmp D[uMsg],WM_CREATE
	jne >>.WM_PAINT
		invoke GetClientRect,[hwnd],offset rect

		invoke GdipCreateFromHWND, [hwnd], offset pEditGraphics

		invoke GdipCreateBitmapFromGraphics,[rect.right], [rect.bottom],[pEditGraphics],offset pPic
		
		invoke GdipGraphicsClear,[pEditGraphics],Black

		invoke SetWindowLong,[hwnd],GWL_USERDATA, [pPic]
		// Default color
		invoke SetWindowLong,[hwnd],0,Black

		// Fill the bitmap with transparent White
	;	invoke GdipBitmapFillBackground,[pPic],0x00FFFFFF

		invoke GdipCreateSolidFill,White,offset BkgndBrush
		invoke GdipSetPixelOffsetMode,[pEditGraphics],PixelOffsetModeHighQuality
		invoke GdipSetCompositingMode,[pEditGraphics],CompositingModeSourceOver
		invoke GdipSetCompositingQuality,[pEditGraphics],CompositingQualityHighQuality
		invoke GdipSetInterpolationMode,[pEditGraphics],InterpolationModeHighQualityBicubic
		jmp >>.DEFPROC

	.PB_SETIMAGE
	cmp D[uMsg],PB_SETIMAGE
	jne >>.WM_PAINT

	.WM_PAINT
	cmp D[uMsg],WM_PAINT
	jne >>.WM_LBUTTONDOWN
		invoke BeginPaint,[hwnd],offset ps
		invoke GdipDrawImageRectI,[pEditGraphics],[pPic],0,0,384,384
		invoke EndPaint,[hwnd],offset ps
		xor rax,rax
		ret

	.WM_LBUTTONDOWN
		cmp D[uMsg],WM_LBUTTONDOWN
		jne >>.WM_LBUTTONUP

		.POINT_PEN
			invoke GetWindowRect,[hwnd],offset rect
			add D[rect.left],1
			add D[rect.top],1
			sub D[rect.right],1
			sub D[rect.bottom],1
			invoke ClipCursor,offset rect

			mov eax,[lParam]
			and eax,0xFFFF
			mov [Oldpt.x],eax
			mov eax,[lParam]
			shr eax,16
			mov [Oldpt.y],eax

			invoke GdipGetImageWidth,[pPic],offset Scale

			invoke GetWindowLong,[hwnd],0
			mov [color],eax

			invoke GdipBitmapLockBits,[pPic],NULL,ImageLockModeWrite + ImageLockModeRead,[PixelFormat],offset bmd

			invoke GdipSetBitmapPixel,[Oldpt.x],[Oldpt.y],[bmd.Scan0],[bmd.Stride],[color]

			invoke GdipBitmapUnlockBits,[pPic],offset bmd

			invoke InvalidateRect,[hwnd],NULL,TRUE
			mov D[fDrawing],TRUE

			jmp >>.DEFPROC

	.WM_LBUTTONUP
		cmp D[uMsg],WM_LBUTTONUP
		jne >>.WM_MOUSEMOVE
			invoke ClipCursor,NULL
			mov D[fDrawing],FALSE
			invoke InvalidateRect,[hwnd],NULL,TRUE
			jmp >>.DEFPROC

	.WM_MOUSEMOVE
		cmp D[uMsg],WM_MOUSEMOVE
		jne >>.WM_ERASEBKGND

		.LINE
			cmp D[fDrawing],TRUE
			jne >>.DEFPROC
			invoke GetWindowLong,[hwnd],0
			mov [color],eax

			mov eax,[lParam]
			and eax,0xFFFF
			mov [pt.x],eax
			mov eax,[lParam]
			shr eax,16
			mov [pt.y],eax

			invoke GdipBitmapDrawLine,[pPic],[Oldpt.x],[Oldpt.y],[pt.x],[pt.y],[color]
			mov ecx,[pt.x]
			mov [Oldpt.x],ecx
			mov edx,[pt.y]
			mov [Oldpt.y],edx
			invoke InvalidateRect,[hwnd],NULL,TRUE

			jmp >>.DEFPROC

	.WM_ERASEBKGND
	cmp D[uMsg],WM_ERASEBKGND
	jne >>.WM_DESTROY
		// Supress erase background if drawing
		// this eliminates flicker which is really
		// bad with GDI+
		cmp D[fDrawing],TRUE
		jne >
		ret
		:
		invoke GdipFillRectangleI,[pEditGraphics],[BkgndBrush],0,0,384,384
		ret

	.WM_DESTROY
	cmp D[uMsg],WM_DESTROY
	jne >>.DEFPROC
		invoke GetWindowLong,[hwnd],GWL_USERDATA
		invoke GdipDisposeImage,rax
		invoke GdipDeleteBrush,[BkgndBrush]
		invoke GdipDeleteGraphics, [pEditGraphics]

	.DEFPROC
	invoke DefWindowProc, [hwnd], [uMsg], [wParam], [lParam]
	RET
ENDF

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses ebx

	cmp D[uMsg],WM_INITDIALOG
	jne >>.WM_COMMAND
		invoke GetDlgItem,[hwnd],1001
		mov [hPictureBox],eax

		invoke GetDlgItem,[hwnd],1004
		mov [hAlpha],eax
		invoke SendMessage,[hAlpha],TBM_SETRANGE,FALSE,255<<16
		invoke SendMessage,[hAlpha],TBM_SETPOS,TRUE,0
		invoke GetDlgItem,[hwnd],1005
		mov [hAlphaEdit],eax
		invoke SetDlgItemInt,[hwnd],1005,255,TRUE
		// We'll start with red
		invoke SetWindowLong,[hPictureBox],0,Black

		jmp >>.EXIT

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >>.WM_VSCROLL
		mov ebx,[wParam]
		and ebx,0xFFFF
		cmp ebx,1002
		jne >>
			invoke GetVersionString,"Gdiplus.dll",offset VersionString
			invoke MessageBox,NULL,offset VersionString,"GDIPlus version",MB_OK
		:
		cmp ebx,BTN_ALPHA_OPAQUE
		jne >>
			invoke SetDlgItemInt,[hwnd],1005,255,TRUE
			invoke SendMessage,[hAlpha],TBM_SETPOS,TRUE,0
			jmp >>.SETALPHA
		:
		cmp ebx,BTN_ALPHA_75PER
		jne >>
			invoke SetDlgItemInt,[hwnd],1005,192,TRUE
			invoke SendMessage,[hAlpha],TBM_SETPOS,TRUE,64
			jmp >>.SETALPHA
		:
		cmp ebx,BTN_ALPHA_50PER
		jne >>
			invoke SetDlgItemInt,[hwnd],1005,128,TRUE
			invoke SendMessage,[hAlpha],TBM_SETPOS,TRUE,128
			jmp >>.SETALPHA
		:
		cmp ebx,BTN_ALPHA_25PER
		jne >>
			invoke SetDlgItemInt,[hwnd],1005,64,TRUE
			invoke SendMessage,[hAlpha],TBM_SETPOS,TRUE,192
			jmp >>.SETALPHA
		:
		cmp ebx,BTN_ALPHA_TRANS
		jne >>.EXIT
			invoke SetDlgItemInt,[hwnd],1005,0,TRUE
			invoke SendMessage,[hAlpha],TBM_SETPOS,TRUE,255
			jmp >>.SETALPHA

		.SETALPHA
		invoke GetWindowLong,[hPictureBox],0
		and eax, !AlphaMask
		mov ebx, eax
		invoke SendMessage,[hAlpha],TBM_GETPOS,0,0
		sub eax,255
		neg eax
		shl eax, AlphaShift
		or eax,ebx
		invoke SetWindowLong,[hPictureBox],0,eax
		xor eax,eax
		jmp >>.EXIT

	.WM_VSCROLL
	cmp D[uMsg],WM_VSCROLL
	jne >.WM_NOTIFY
			// We will not use the WM_VSCROLL message to actually set the alpha
			// channel value, only to display it in the buddy. The channel will
			// be set with the NM_RELEASEDCAPTURE notification, that way it will
			// only change when the user stops scrolling
			invoke SendMessage,[hAlpha],TBM_GETPOS,0,0
			sub eax,255
			neg eax
			invoke SetDlgItemInt,[hwnd],1005,eax,TRUE
			jmp >>.DEFPROC

	.WM_NOTIFY
	cmp D[uMsg],WM_NOTIFY
	jne >.WM_CLOSE
		mov ebx,[lParam]
		cmp D[ebx+NMHDR.code],NM_RELEASEDCAPTURE
		jne >>.DEFPROC
			invoke GetWindowLong,[hPictureBox],0
			and eax, !AlphaMask
			mov ebx, eax
			invoke SendMessage,[hAlpha],TBM_GETPOS,0,0
			sub eax,255
			neg eax
			shl eax, AlphaShift
			or eax,ebx
			invoke SetWindowLong,[hPictureBox],0,eax
			xor eax,eax
			ret

	.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.DEFPROC
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF

/*
ColorBalanceApplyEffect FRAME pBitmap,cyanRed,magentaGreen,yellowBlue
	LOCAL cbparams		:ColorBalanceParams
	LOCAL pEffect		:D
	LOCAL rect			:RECT

	mov eax,[cyanRed]
	mov [cbparams.cyanRed], eax
	mov eax,[magentaGreen]
	mov [cbparams.magentaGreen], eax
	mov eax,[yellowBlue]
	mov [cbparams.yellowBlue], eax

	lea eax,pEffect
	push eax
	pushguid(ColorBalanceEffectGuid)
	call GdipCreateEffect

	invoke GdipSetEffectParameters,[pEffect],offset cbparams,SIZEOF ColorBalanceParams

	mov D[rect.left],0
	mov D[rect.top],0
	invoke GdipGetImageWidth,[pBitmap],offset rect.right
	invoke GdipGetImageHeight,[pBitmap],offset rect.bottom

	invoke GdipBitmapApplyEffect,[pBitmap],[pEffect],offset rect, NULL,NULL,NULL
	invoke GdipDeleteEffect,[pEffect]
	RET
ENDF

BrightnessContrastApplyEffect FRAME pBitmap,Brightness,Contrast
	LOCAL bcparams		:BrightnessContrastParams
	LOCAL pEffect		:D
	LOCAL rect			:RECT

	mov eax,[Brightness]
	mov [bcparams.brightnessLevel], eax
	mov eax,[Contrast]
	mov [bcparams.contrastLevel], eax

	lea eax,pEffect
	push eax
	pushguid(BrightnessContrastEffectGuid)
	call GdipCreateEffect

	invoke GdipSetEffectParameters,[pEffect],offset bcparams,SIZEOF BrightnessContrastParams

	mov D[rect.left],0
	mov D[rect.top],0
	invoke GdipGetImageWidth,[pBitmap],offset rect.right
	invoke GdipGetImageHeight,[pBitmap],offset rect.bottom

	invoke GdipBitmapApplyEffect,[pBitmap],[pEffect],offset rect, NULL,NULL,NULL
	invoke GdipDeleteEffect,[pEffect]
	RET
ENDF

BlurApplyEffect FRAME pBitmap,radius
	LOCAL blurparams	:BlurParams
	LOCAL pEffect		:D
	LOCAL rect			:RECT

	mov eax,[radius]
	mov D[blurparams.radius], eax
	mov D[blurparams.expandEdge], FALSE

	lea eax,pEffect
	push eax
	pushguid(BlurEffectGuid)
	call GdipCreateEffect

	invoke GdipSetEffectParameters,[pEffect],offset blurparams,SIZEOF BlurParams

	mov D[rect.left],0
	mov D[rect.top],0
	invoke GdipGetImageWidth,[pBitmap],offset rect.right
	invoke GdipGetImageHeight,[pBitmap],offset rect.bottom

	invoke GdipBitmapApplyEffect,[pBitmap],[pEffect],offset rect, NULL,NULL,NULL
	invoke GdipDeleteEffect,[pEffect]
	RET
ENDF

SaveBitmapToFile FRAME pImage, pFileName, format, bitdepth
	LOCAL pPal				:%PTR
	LOCAL encoderClsid		:GUID
	LOCAL PalType			:%PTR
	LOCAL ImgFmt			:%PTR

// format constants
;#DEFINE GDIP_IMAGE_BMP 0
;#DEFINE GDIP_IMAGE_JPG 1
;#DEFINE GDIP_IMAGE_GIF 2
;#DEFINE GDIP_IMAGE_EMF 3
;#DEFINE GDIP_IMAGE_WMF 4
;#DEFINE GDIP_IMAGE_TIFF 5
;#DEFINE GDIP_IMAGE_PNG 6
;#DEFINE GDIP_IMAGE_ICON 7

	cmp D[format],GDIP_IMAGE_BMP
	jne >
		invoke memcopy,offset ImageEncoderBMP,offset encoderClsid,SIZEOF GUID
		jmp >>.ENCFOUND
	:
	cmp D[format],GDIP_IMAGE_JPG
	jne >
		invoke memcopy,offset ImageEncoderJPEG,offset encoderClsid,SIZEOF GUID
		jmp >>.ENCFOUND
	:
	cmp D[format],GDIP_IMAGE_GIF
	jne >
		invoke memcopy,offset ImageEncoderGIF,offset encoderClsid,SIZEOF GUID
		jmp >>.ENCFOUND
	:

;	cmp D[format],GDIP_IMAGE_EMF
;	jne >
;		invoke memcopy,offset ImageEncoderEMF,offset encoderClsid,SIZEOF GUID
;		jmp >>.ENCFOUND
;	:
;	cmp D[format],GDIP_IMAGE_WMF
;	jne >
;		invoke memcopy,offset ImageEncoderWMF,offset encoderClsid,SIZEOF GUID
;		jmp >>.ENCFOUND
;	:

	cmp D[format],GDIP_IMAGE_TIFF
	jne >
		invoke memcopy,offset ImageEncoderTIFF,offset encoderClsid,SIZEOF GUID
		jmp >>.ENCFOUND
	:
	cmp D[format],GDIP_IMAGE_PNG
	jne >
		invoke memcopy,offset ImageEncoderPNG,offset encoderClsid,SIZEOF GUID
		jmp >>.ENCFOUND
	:

	invoke IsBadReadPtr,[format],1
	test eax,eax
	jnz >>.ERRORFORMAT

	.GETENC
	invoke GetEncoderClsid,[format], offset encoderClsid
	test eax,eax
	js >>.ERRORFORMAT

	.ENCFOUND

	// The largest palette size is 1024 bytes so we allocate that
	invoke GdipAlloc,1024 + SIZEOF ColorPalette
	mov [pPal],eax

	cmp D[bitdepth],-1
	je >>.NoConvert

	cmp D[bitdepth],8
	jne >
		// Since this is an indexed type use a large palette to find the closest colors
		// it will be reduced to 256 colors by the conversion function
		mov D[PalType],PaletteTypeFixedHalftone27
		mov D[ImgFmt],PixelFormat8bppIndexed
		jmp >>.Convert
	:
	cmp D[bitdepth],24
	jne >
		mov D[PalType],PaletteTypeFixedHalftone27
		mov D[ImgFmt],PixelFormat24bppRGB
		jmp >>.Convert
	:
	cmp D[bitdepth],32
	jne >
		mov D[PalType],PaletteTypeFixedHalftone256
		mov D[ImgFmt],PixelFormat32bppRGB
		jmp >>.Convert
	:

	cmp D[format],GDIP_IMAGE_BMP
	jne >>.NoConvert
	// Bitmap only color depths
	cmp D[bitdepth],16
	jne >
		// There is no standard 16Bpp palette so we use a 24 Bpp. It's not optimal but easier.
		mov D[PalType],PaletteTypeFixedHalftone27
		mov D[ImgFmt],PixelFormat16bppRGB555
		jmp >>.Convert
	:
	cmp D[bitdepth],48
	jne >
		mov D[PalType],PaletteTypeFixedHalftone256
		mov D[ImgFmt],PixelFormat48bppRGB
	:
	cmp D[bitdepth],64
	jne >.NoConvert
		mov D[PalType],PaletteTypeFixedHalftone256
		mov D[ImgFmt],PixelFormat64bppARGB

	.Convert
	invoke GdipInitializePalette,[pPal], [PalType], 0, TRUE, NULL

	invoke GdipBitmapConvertFormat,[pImage],[ImgFmt], DitherTypeNone,[PalType],[pPal],50.0
	.NoConvert

	invoke GdipSaveImageToFile,[pImage], [pFileName],offset encoderClsid,NULL
	test eax,eax
	jnz >>.NOSAVE

	invoke GdipDisposeImage,[pImage]

	invoke GdipFree,[pPal]
	invoke SetLastError,0
	xor eax,eax
	RET

	.NOIMG
	invoke SetLastError,ERROR_INVALID_HANDLE
	xor eax,eax
	dec eax
	RET

	.ERRORFORMAT
	invoke GdipDisposeImage,[pImage]
	invoke SetLastError,ERROR_NOT_SUPPORTED
	xor eax,eax
	dec eax
	RET

	.NOSAVE
	invoke GdipDisposeImage,[pImage]
	invoke GdipFree,[pPal]
	// GdipSaveImageToFile seems to set the error code properly so leave it
	xor eax,eax
	dec eax
	RET

	STRENCBMP:	DUS "image/bmp",0
	STRENCGIF:	DUS "image/gif",0
	STRENCJPG:	DUS "image/jpeg",0
	STRENCTIF:	DUS "image/tiff",0
	STRENCPNG:	DUS "image/png",0

ENDF

GetEncoderClsid FRAME format, pClsid
	uses edi,ebx,esi
	LOCAL num	:D	// number of image encoders
	LOCAL size	:D	// size of the image encoder array in bytes
	LOCAL pImageCodecInfo	:D

	mov D[num],0
	mov D[size],0

	invoke GdipGetImageEncodersSize, offset num, offset size
	cmp D[size],0
	je >>.ERROR

	invoke GdipAlloc,[size]
	mov [pImageCodecInfo],eax
	test eax,eax
	jz >>.ERROR

	// Scan through the codecs
	invoke GdipGetImageEncoders,[num],[size],[pImageCodecInfo]
	xor ebx,ebx
	dec ebx

	.NEXTCODEC
	inc ebx
	cmp ebx,[num]
	jg >.EXIT
		imul esi,ebx,SIZEOF ImageCodecInfo
		add esi,ImageCodecInfo.MimeType
		add esi,[pImageCodecInfo]
		invoke lstrcmpiW,[esi],[format]
		test eax,eax
		jnz <.NEXTCODEC
			imul esi,ebx,SIZEOF ImageCodecInfo
			add esi,[pImageCodecInfo]
			add esi, ImageCodecInfo.Clsid
			invoke memcopy,esi,[pClsid],SIZEOF GUID
			invoke GdipFree,[pImageCodecInfo]
			mov eax,ebx
			ret
	.EXIT

	invoke GdipFree,[pImageCodecInfo]
   .ERROR
   xor eax,eax
   dec eax
   ret
ENDF

memcopy FRAME lpSource,lpDest,nBytes
	uses edi,esi,ecx
	cld
	mov edi,[lpDest]
	mov esi,[lpSource]
	mov ecx,[nBytes]
	
	; do the evenly divisible ones
	shr ecx,2
	rep movsd
	
	; do the remainder
	mov ecx,[nBytes]
	and ecx,3
	rep movsb
	
	RET
ENDF
*/

// Vector functions for gdiplus image object

GdipSetBitmapPixel FRAME x, y, pBits, stride, color

	mov rcx,[x]
	shl rcx,2 ; 4*X
	cmp rcx,[stride]
	ja >.EXIT

	mov rax,[y]
	mul D[stride]

	add rax,ecx
	add rax,[pBits]
	mov rdx,[color]
	mov [rax],rdx
	ret

	.EXIT
	RET
ENDF

GdipGetBitmapPixel FRAME x, y, pBits, stride

	mov rcx,[x]
	shl rcx,2 ; 4*X
	cmp rcx,[stride]
	ja >.EXIT

	mov rax,[y]
	mul D[stride]

	add rax,ecx
	add rax,[pBits]
	mov eax,[rax]
	ret

	.EXIT
	RET
ENDF

GdipBitmapDrawLine FRAME pBitmapObject,x1,y1,x2,y2,color
	uses edi,esi,ebx
	LOCAL ix,iy,idx,idy,incx,incy,balance
	LOCAL bmd:BitmapData
	LOCAL rect	:RECT


	// Bresenham Line

	invoke GdipBitmapLockBits,[pBitmapObject],NULL,ImageLockModeWrite + ImageLockModeRead,[PixelFormat],offset bmd

	; Limit the drawing to the surface
	mov eax,[x1]	
	or eax,eax
	jns >
		xor eax,eax
	:
	cmp eax,[bmd.Width]
	jl >
		mov eax,[bmd.Width]
		dec eax
	:
	mov [x1],eax
	
	mov eax,[x2]
	or eax,eax
	jns >
		xor eax,eax
	:
	cmp eax,[bmd.Width]
	jl >
		mov eax,[bmd.Width]
		dec eax
	:
	mov [x2],eax

	mov eax,[y1]
	or eax,eax
	jns >
		xor eax,eax
	:
	cmp eax,[bmd.Height]
	jl >
		mov eax,[bmd.Height]
		dec eax
	:
	mov [y1],eax

	mov eax,[y2]
	or eax,eax
	jns >
		xor eax,eax
	:
	cmp eax,[bmd.Height]
	jl >
		mov eax,[bmd.Height]
		dec eax
	:
	mov [y2],eax


	// real drawing starts here

	mov ebx,[bmd.Scan0]

	mov eax,[x2]
	cmp eax,[x1]
	jl >
		sub eax,[x1]
		mov D[incx],1
		jmp >C1
	:
		mov eax,[x1]
		sub eax,[x2]
		mov D[incx],-1
	C1:
	mov [idx],eax
	
	mov eax,[y2]
	cmp eax,[y1]
	jl >
		sub eax,[y1]
		mov D[incy],1
		jmp >C1
	:
		mov eax,[y1]
		sub eax,[y2]
		mov D[incy],-1
	C1:
	mov [idy],eax
	
	mov eax,[x1]
	mov [ix],eax
	mov eax,[y1]
	mov [iy],eax

	mov eax,[idx]
	cmp eax,[idy]
	jl >>L1
		mov eax,[idy]
		mov ecx,[idx]

		shl eax,1
		mov [idy],eax

		sub eax,ecx
		mov [balance],eax

		shl ecx,1
		mov [idx],ecx

		mov edi,[ix]
		mov esi,[iy]
		jmp >W1
		W0:
			invoke GdipSetBitmapPixel,edi,esi,ebx,[bmd.Stride],[color]
			cmp D[balance],0
			jl >
				add esi,[incy]
				mov eax,[idx]
				sub [balance],eax
			:
			mov eax,[idy]
			add [balance],eax
			add edi,[incx]
		W1:
		cmp edi,[x2]
		jne <W0
		invoke GdipSetBitmapPixel,edi,esi,ebx,[bmd.Stride],[color]

		invoke GdipBitmapUnlockBits,[pBitmapObject],offset bmd
		xor eax,eax
		ret

	L1:
		mov eax,[idx]
		mov ecx,[idy]

		shl eax,1
		mov [idx],eax

		sub eax,ecx
		mov [balance],eax

		shl ecx,1
		mov [idy],ecx

		mov edi,[ix]
		mov esi,[iy]
		jmp >W4
		W3:
			invoke GdipSetBitmapPixel,edi,esi,ebx,[bmd.Stride],[color]
			cmp D[balance],0
			jl >
				add edi,[incx]
				mov eax,[idy]
				sub [balance],eax
			:
			mov eax,[idx]
			add [balance],eax
			add esi,[incy]
		W4:
		cmp esi,[y2]
		jne <W3
		invoke GdipSetBitmapPixel,edi,esi,ebx,[bmd.Stride],[color]

		invoke GdipBitmapUnlockBits,[pBitmapObject],offset bmd
		xor eax,eax

		ret
ENDF

GdipBitmapFillBackground FRAME pBitmapObject, color
	uses edi,esi
	LOCAL bmd:BitmapData
	LOCAL rect	:RECT

	invoke GdipBitmapLockBits,[pBitmapObject],NULL,ImageLockModeWrite,[PixelFormat],offset bmd

	mov edi,[bmd.Height]
	.ROW
	mov esi,[bmd.Width]
	dec edi
	test edi,edi
	js >.ENDFILL
	.COLUMN
	dec esi
	test esi,esi
	js .ROW
	mov ecx,esi
	shl ecx,2 ; 4*X
	mov eax,edi
;	shl eax,2 ; Width*4*Y
	mul D[bmd.Stride]
	add eax,ecx
	add eax,[bmd.Scan0]
	mov edx,[color]
	mov [eax],edx
	jmp .COLUMN

	.ENDFILL
	invoke GdipBitmapUnlockBits,[pBitmapObject],offset bmd

	RET
ENDF

